// XGina.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "XGina.h"

#define _WIN32_WINNT 0x0400
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <winwlx.h>
#include <assert.h>
#include <lm.h>
#include <Winwlx.h>


//
// MSGINA dialog box IDs.p
//
#define IDD_WLXDIAPLAYSASNOTICE_DIALOG		  1400
#define IDD_WLXLOGGEDOUTSAS_DIALOG				1450
#define IDD_CHANGE_PASSWORD_DIALOG			    1550
#define IDD_WLXLOGGEDONSAS_DIALOG				  1650
#define IDD_WLXWKSTALOCKEDSAS_DIALOG           1850

//
// MSGINA control IDs
//
#define IDC_WLXLOGGEDOUTSAS_USERNAME      1453
#define IDC_WLXLOGGEDOUTSAS_PASSWORD      1454
#define IDC_WLXLOGGEDOUTSAS_DOMAIN			    1455
#define IDC_WLXWKSTALOCKEDSAS_DOMAIN          1856

//
// Pointers to redirected functions.
//

static PWLX_DIALOG_BOX_PARAM pfWlxDialogBoxParam = NULL;

//
// Pointers to redirected dialog box.
//

static DLGPROC pfWlxLoggedOutSASDlgProc   = NULL;
static DLGPROC pfWlxWkstaLockedSASDlgProc = NULL;
static DLGPROC pfChangePasswordDlgProc    = NULL;

static DLGPROC pfWlxDisplaySASDlgProc = NULL;
static DLGPROC pfWlxLoggedOnSASDlgProc = NULL;


//
// Location of the real MSGINA.
//

#define REALGINA_PATH      TEXT("MSGINA.DLL")
#define GINASTUB_VERSION   (WLX_VERSION_1_3) // Highest version supported at
                                             // this point. Remember to modify
                                             // this as support for newer version
                                             // is added to this program.
//
// Winlogon function dispatch table.
//
static PVOID g_pWinlogon = NULL;
static DWORD g_dwVersion = WLX_VERSION_1_3;

//
// Pointers to the real MSGINA functions.
//

//
// Function prototypes for the GINA interface.
//

typedef BOOL (WINAPI * PFWLXNEGOTIATE)  (DWORD, DWORD *);
typedef BOOL (WINAPI * PFWLXINITIALIZE) (LPWSTR, HANDLE, PVOID, PVOID, PVOID *);
typedef VOID (WINAPI * PFWLXDISPLAYSASNOTICE) (PVOID);
typedef int  (WINAPI * PFWLXLOGGEDOUTSAS) (PVOID, DWORD, PLUID, PSID, PDWORD,
                                           PHANDLE, PWLX_MPR_NOTIFY_INFO, 
                                           PVOID *);
typedef BOOL (WINAPI * PFWLXACTIVATEUSERSHELL) (PVOID, PWSTR, PWSTR, PVOID);
typedef int  (WINAPI * PFWLXLOGGEDONSAS) (PVOID, DWORD, PVOID);
typedef VOID (WINAPI * PFWLXDISPLAYLOCKEDNOTICE) (PVOID);
typedef int  (WINAPI * PFWLXWKSTALOCKEDSAS) (PVOID, DWORD);
typedef BOOL (WINAPI * PFWLXISLOCKOK) (PVOID);
typedef BOOL (WINAPI * PFWLXISLOGOFFOK) (PVOID);
typedef VOID (WINAPI * PFWLXLOGOFF) (PVOID);
typedef VOID (WINAPI * PFWLXSHUTDOWN) (PVOID, DWORD);

//
// New for version 1.1
//

typedef BOOL (WINAPI * PFWLXSCREENSAVERNOTIFY) (PVOID, BOOL *);
typedef BOOL (WINAPI * PFWLXSTARTAPPLICATION) (PVOID, PWSTR, PVOID, PWSTR);

//
// New for version 1.3
//

typedef BOOL (WINAPI * PFWLXNETWORKPROVIDERLOAD) (PVOID, PWLX_MPR_NOTIFY_INFO);
typedef BOOL (WINAPI * PFWLXDISPLAYSTATUSMESSAGE) (PVOID, HDESK, DWORD, PWSTR, PWSTR);
typedef BOOL (WINAPI * PFWLXGETSTATUSMESSAGE) (PVOID, DWORD *, PWSTR, DWORD);
typedef BOOL (WINAPI * PFWLXREMOVESTATUSMESSAGE) (PVOID);

static PFWLXNEGOTIATE						   pfWlxNegotiate;
static PFWLXINITIALIZE							    pfWlxInitialize;
static PFWLXDISPLAYSASNOTICE			  pfWlxDisplaySASNotice;
static PFWLXLOGGEDOUTSAS					pfWlxLoggedOutSAS;
static PFWLXACTIVATEUSERSHELL		    pfWlxActivateUserShell;
static PFWLXLOGGEDONSAS					  pfWlxLoggedOnSAS;
static PFWLXDISPLAYLOCKEDNOTICE     pfWlxDisplayLockedNotice;
static PFWLXWKSTALOCKEDSAS			  pfWlxWkstaLockedSAS;
static PFWLXISLOCKOK							  pfWlxIsLockOk;
static PFWLXISLOGOFFOK						  pfWlxIsLogoffOk;
static PFWLXLOGOFF								   pfWlxLogoff;
static PFWLXSHUTDOWN						pfWlxShutdown;

//
// New for version 1.1
//

static PFWLXSTARTAPPLICATION     pfWlxStartApplication  = NULL;
static PFWLXSCREENSAVERNOTIFY    pfWlxScreenSaverNotify = NULL;

//
// New for version 1.2 - No new GINA interface was added, except
//                       a new function in the dispatch table.
//

//
// New for version 1.3
//

static PFWLXNETWORKPROVIDERLOAD   pfWlxNetworkProviderLoad  = NULL;
static PFWLXDISPLAYSTATUSMESSAGE  pfWlxDisplayStatusMessage = NULL;
static PFWLXGETSTATUSMESSAGE      pfWlxGetStatusMessage     = NULL;
static PFWLXREMOVESTATUSMESSAGE   pfWlxRemoveStatusMessage  = NULL;

void  WINAPI  DrawLogo(HWND hwndDlg ,LPCTSTR lpszFileName,INT x ,INT y);
BOOL LoadBitmapFromBMPFile( LPTSTR szFileName, HBITMAP *phBitmap, HPALETTE *phPalette );

#ifdef _DEBUG
#define	LOG_PATH		TEXT("c:\\xgina.log")
void DEBUG_MSG(const char *szMsg, ... );
#endif

#define		IMAGE_FILE			TEXT("xgina.dat")

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}


// This is an example of an exported variable
//CSIGINA_API int nCSIGina=0;
//
// This is an example of an exported function.
//CSIGINA_API int fnCSIGina(void)
//{
//	return 42;
//}
//
// This is the constructor of a class that has been exported.
// see CSIGina.h for the class definition
//CCSIGina::CCSIGina()
//{ 
//	return; 
//}



//
// Local functions.
//

int WINAPI MyWlxDialogBoxParam (HANDLE, HANDLE, LPWSTR, HWND, DLGPROC, LPARAM);

//
// Local variables.
//

static char g_szLocalMachineName[256] = "";


//
// Hook WlxDialogBoxParam() dispatch function.
//
void HookWlxDialogBoxParam (PVOID pWinlogonFunctions, DWORD dwWlxVersion)
{
   //
   // Hook WlxDialogBoxParam(). Note that we chould cheat here by always
   // casting to (PWLX_DISPATCH_VERSION_1_0) since WlxDialogBoxParam()
   // exists in all versions and is always in the same location of the
   // dispatch table. But, we will do it the hard way!
   //
   switch (dwWlxVersion)
   {
      case WLX_VERSION_1_0: 
      {
         pfWlxDialogBoxParam = 
            ((PWLX_DISPATCH_VERSION_1_0) pWinlogonFunctions)->WlxDialogBoxParam;
         ((PWLX_DISPATCH_VERSION_1_0) pWinlogonFunctions)->WlxDialogBoxParam = 
            MyWlxDialogBoxParam;
#ifdef _DEBUG
	    DEBUG_MSG("PWLX_DISPATCH_VERSION_1_0)");
#endif
         break;
      }
  
      case WLX_VERSION_1_1:
      {
         pfWlxDialogBoxParam = 
            ((PWLX_DISPATCH_VERSION_1_1) pWinlogonFunctions)->WlxDialogBoxParam;
         ((PWLX_DISPATCH_VERSION_1_1) pWinlogonFunctions)->WlxDialogBoxParam = 
            MyWlxDialogBoxParam;
#ifdef _DEBUG
	    DEBUG_MSG("PWLX_DISPATCH_VERSION_1_1)");
#endif
         break;
      }
   
      case WLX_VERSION_1_2:
      {
         pfWlxDialogBoxParam = 
            ((PWLX_DISPATCH_VERSION_1_2) pWinlogonFunctions)->WlxDialogBoxParam;
         ((PWLX_DISPATCH_VERSION_1_2) pWinlogonFunctions)->WlxDialogBoxParam = 
            MyWlxDialogBoxParam;

#ifdef _DEBUG
	    DEBUG_MSG("PWLX_DISPATCH_VERSION_1_2)");
#endif
         break;
      }
   
      default:
      {
         pfWlxDialogBoxParam = 
            ((PWLX_DISPATCH_VERSION_1_3) pWinlogonFunctions)->WlxDialogBoxParam;
         ((PWLX_DISPATCH_VERSION_1_3) pWinlogonFunctions)->WlxDialogBoxParam = 
            MyWlxDialogBoxParam;
#ifdef _DEBUG
			DEBUG_MSG("PWLX_DISPATCH_VERSION_1_3)");
#endif
         break;
      }
   }
}


//
// Redirected WlxLoggedOutSASDlgProc().
//

BOOL CALLBACK  
MyWlxLoggedOutSASDlgProc (HWND   hwndDlg,  // handle to dialog box
                          UINT   uMsg,     // message  
                          WPARAM wParam,   // first message parameter
                          LPARAM lParam)   // second message parameter
{
	BOOL bResult;
   
   //
   // Sanity check.
   //
   assert(pfWlxLoggedOutSASDlgProc != NULL);
   
   //
   // Pass on to MSGINA first.
   //
   bResult = pfWlxLoggedOutSASDlgProc(hwndDlg, uMsg, wParam, lParam);

   //
   // We are only interested in WM_INITDIALOG message.
   //
#ifdef _DEBUG
	DEBUG_MSG("Logout dlg msg id : %ld" , uMsg);
#endif
	if (uMsg == WM_INITDIALOG)
	{
		 DWORD dwIndex;
		 HWND hwndDomain;
		 NET_API_STATUS netstatus;
		 LPWKSTA_INFO_100 lpWkstaInfo;

#ifdef _DEBUG
		 DEBUG_MSG("Logout state init");		
#endif

		 //
		 // Get local machine name.
		 //
		 netstatus = NetWkstaGetInfo(NULL, 100, (LPBYTE *) &lpWkstaInfo);
		 if (netstatus != NERR_Success)
		 {
			return bResult;
		 }            

		 //
		 // Convert to ANSI.
		 //
		 wcstombs(g_szLocalMachineName, lpWkstaInfo->wki100_computername, 
				sizeof(g_szLocalMachineName));

		 //
		 // and free the buffer.
		 //
		 NetApiBufferFree((LPVOID) lpWkstaInfo);

		 //
		 // Manipulate the domain combo box so that only some predetermined
		 // trusted domains are included in the list.
		 //
		 // In our case, we restrict logon to local machine only.
		 //
		 hwndDomain = GetDlgItem(hwndDlg, IDC_WLXLOGGEDOUTSAS_DOMAIN);
		 if (hwndDomain == NULL)
		 {
			return bResult;
		 }

		 dwIndex = (DWORD) SendMessage(hwndDomain, CB_FINDSTRING, 
								 0, (LPARAM) g_szLocalMachineName);
		 if (dwIndex != CB_ERR)
		 {
			SendMessage(hwndDomain, CB_SETCURSEL, (WPARAM) dwIndex, 0);
			EnableWindow(hwndDomain, FALSE);
		 }
	}
	else if ( uMsg == WM_PAINT)
	{	
		RECT rect;
		GetClientRect( hwndDlg , &rect);
		rect.top = rect.bottom - 33;
		DrawLogo(hwndDlg,IMAGE_FILE,rect.left , rect.top);
	}

   return bResult;
}


//
// Redirected WlxWkstaLockedSASDlgProc().
//

BOOL 
CALLBACK 
MyWlxWkstaLockedSASDlgProc (HWND   hwndDlg,  // handle to dialog box
                            UINT   uMsg,     // message  
                            WPARAM wParam,   // first message parameter
                            LPARAM lParam)   // second message parameter
{
	BOOL bResult;
   
   //
   // Sanity check.
   //
   assert(pfWlxWkstaLockedSASDlgProc != NULL);
   
   //
   // Pass on to MSGINA first.
   //
   bResult = pfWlxWkstaLockedSASDlgProc(hwndDlg, uMsg, wParam, lParam);

   //
   // We are only interested in WM_INITDIALOG message.
   //
#ifdef _DEBUG
   DEBUG_MSG("Lock workstation dlg msg id : %ld" , uMsg);
#endif

	if (uMsg == WM_INITDIALOG)
	{
		DWORD dwIndex;

#ifdef _DEBUG		
		DEBUG_MSG("Log workstation dlg init");		
#endif
		//
		// Make sure to cover this hole.
		//
		HWND hwndDomain = GetDlgItem(hwndDlg, IDC_WLXWKSTALOCKEDSAS_DOMAIN);
		if (hwndDomain == NULL)
		{
			return bResult;
		}

		dwIndex = (DWORD) SendMessage(hwndDomain, CB_FINDSTRING, 
                                    0, (LPARAM) g_szLocalMachineName);
		if (dwIndex != CB_ERR)
		{
			SendMessage(hwndDomain, CB_SETCURSEL, (WPARAM) dwIndex, 0);
			EnableWindow(hwndDomain, FALSE);
		}
	}
	if ( uMsg == WM_PAINT)
	{	
//		RECT rect;
//		GetClientRect( hwndDlg , &rect);
//		rect.top = rect.bottom - 60;
//		rect.left = rect.right - 214;
//		DrawLogo(hwndDlg,IMAGE_FILE,rect.left , rect.top);
	}

   return bResult;
}


//
// Redirected ChangePasswordDlgProc().
//

BOOL 
CALLBACK 
MyChangePasswordDlgProc (HWND   hwndDlg,  // handle to dialog box
                         UINT   uMsg,     // message  
                         WPARAM wParam,   // first message parameter
                         LPARAM lParam)   // second message parameter
{
   BOOL bResult;
   
   //
   // Sanity check.
   //
   assert(pfChangePasswordDlgProc != NULL);

   //
   // Pass on to MSGINA first.
   //
   bResult = pfChangePasswordDlgProc(hwndDlg, uMsg, wParam, lParam);

   //
   // We are only interested in WM_INITDIALOG message.
   //
#ifdef _DEBUG
   DEBUG_MSG("Change pwd dlg msg id : %ld" , uMsg);
#endif

   if (uMsg == WM_INITDIALOG)
   {
#ifdef _DEBUG
	   DEBUG_MSG("Change pwd dlg init");
#endif
      //
      // Manipulate the dialog box to match your needs here. For example,
      // you can add a static control to the dialog box or display another
      // message to clearly explain the rules for composing a valid password.
      //
	}
	else if ( uMsg == WM_PAINT)
	{	RECT rect;
		GetClientRect( hwndDlg , &rect);
		rect.top = rect.bottom - 33;
		 rect.left = rect.left + 10;
		DrawLogo(hwndDlg,IMAGE_FILE,rect.left , rect.top);
	}

   return bResult;
}


BOOL 
CALLBACK 
MyWlxDisplaySASDlgProc (HWND   hwndDlg,  
                         UINT   uMsg,     
                         WPARAM wParam, 
                         LPARAM lParam)  
{	
	BOOL bResult;
   
   //
   // Sanity check.
   //
	assert(pfWlxDisplaySASDlgProc != NULL);

   //
   // Pass on to MSGINA first.
   //
   bResult = pfWlxDisplaySASDlgProc(hwndDlg, uMsg, wParam, lParam);

   //
   // We are only interested in WM_INITDIALOG message.
   //
#ifdef _DEBUG
   DEBUG_MSG("display SAS dlg msg id : %ld" , uMsg);
#endif

   if (uMsg == WM_INITDIALOG)
   {
#ifdef _DEBUG
	   DEBUG_MSG("display SAS dlg init");
#endif
      //
      // Manipulate the dialog box to match your needs here. For example,
      // you can add a static control to the dialog box or display another
      // message to clearly explain the rules for composing a valid password.
      //
	}
	else if ( uMsg == WM_PAINT)
	{	RECT rect;
		GetClientRect( hwndDlg , &rect);
		rect.top = rect.bottom - 33;
		DrawLogo(hwndDlg,IMAGE_FILE,rect.left , rect.top);
	}

   return bResult;
}

BOOL 
CALLBACK 
MyWlxLoggedOnSASDlgProc (HWND   hwndDlg,  
                         UINT   uMsg,     
                         WPARAM wParam, 
                         LPARAM lParam)  
{	
	BOOL bResult;
   
   //
   // Sanity check.
   //
	assert(pfWlxLoggedOnSASDlgProc != NULL);

   //
   // Pass on to MSGINA first.
   //
   bResult = pfWlxLoggedOnSASDlgProc(hwndDlg, uMsg, wParam, lParam);

   //
   // We are only interested in WM_INITDIALOG message.
   //
#ifdef _DEBUG
   DEBUG_MSG("Log on SAS dlg msg id : %ld" , uMsg);
#endif
   if (uMsg == WM_INITDIALOG)
   {
#ifdef _DEBUG
	   DEBUG_MSG("Log on SAS dlg init");
#endif
      //
      // Manipulate the dialog box to match your needs here. For example,
      // you can add a static control to the dialog box or display another
      // message to clearly explain the rules for composing a valid password.
      //
	}
	else if ( uMsg == WM_PAINT)
	{	RECT rect;
		GetClientRect( hwndDlg , &rect);
		rect.top = rect.bottom - 33;
		DrawLogo(hwndDlg,IMAGE_FILE,rect.left , rect.top);
	}

   return bResult;
}

//
// Redirected WlxDialogBoxParam() function.
//

int 
WINAPI 
MyWlxDialogBoxParam (HANDLE  hWlx,
                     HANDLE  hInst,
                     LPWSTR  lpszTemplate,
                     HWND    hwndOwner,
                     DLGPROC dlgprc,
                     LPARAM  dwInitParam)
{
   //
   // Sanity check.
   //
   assert(pfWlxDialogBoxParam != NULL);

   //
   // We only know MSGINA dialogs by identifiers.
   //
   
   if (!HIWORD(lpszTemplate))
   {
      //
      // Hook appropriate dialog boxes as necessary.
      //
#ifdef _DEBUG
	   DEBUG_MSG("WlxDialogBoxParam :%ld",(DWORD) lpszTemplate);
#endif
      switch ((DWORD) lpszTemplate)
      {
		case IDD_WLXDIAPLAYSASNOTICE_DIALOG:
		{
#ifdef _DEBUG
			DEBUG_MSG("WlxDialogBoxParam : WLXDIAPLAYSASNOTICE_DIALOG");	
#endif
			pfWlxDisplaySASDlgProc = dlgprc;
			return pfWlxDialogBoxParam(hWlx, hInst, lpszTemplate, hwndOwner, 
                                       MyWlxDisplaySASDlgProc, dwInitParam);
		}

		case 1500:
	     case IDD_WLXLOGGEDOUTSAS_DIALOG:
         {
#ifdef _DEBUG
			DEBUG_MSG("WlxDialogBoxParam : WLXLOGGEDOUTSAS_DIALOG");
#endif
            pfWlxLoggedOutSASDlgProc = dlgprc;
            return pfWlxDialogBoxParam(hWlx, hInst, lpszTemplate, hwndOwner, 
                                       MyWlxLoggedOutSASDlgProc, dwInitParam);
         }
	    case 1900:
         case IDD_WLXWKSTALOCKEDSAS_DIALOG:
         {
#ifdef _DEBUG		    
		    DEBUG_MSG("WlxDialogBoxParam : WLXWKSTALOCKEDSAS_DIALOG");
#endif
            pfWlxWkstaLockedSASDlgProc = dlgprc;
            return pfWlxDialogBoxParam(hWlx, hInst, lpszTemplate, hwndOwner, 
                                       MyWlxWkstaLockedSASDlgProc, dwInitParam);
         }
	    case 1950:
	    case IDD_WLXLOGGEDONSAS_DIALOG:
		{	
#ifdef _DEBUG			
			DEBUG_MSG("WlxDialogBoxParam : WLXLOGGEDONSAS_DIALOG");
#endif
			pfWlxLoggedOnSASDlgProc = dlgprc;
			return pfWlxDialogBoxParam(hWlx, hInst, lpszTemplate, hwndOwner, 
                                       MyWlxLoggedOnSASDlgProc, dwInitParam);
		}
	    case 1700:
         case IDD_CHANGE_PASSWORD_DIALOG:
         {	
#ifdef _DEBUG		    
		    DEBUG_MSG("WlxDialogBoxParam : CHANGE_PASSWORD_DIALOG");
#endif
            pfChangePasswordDlgProc = dlgprc;
            return pfWlxDialogBoxParam(hWlx, hInst, lpszTemplate, hwndOwner, 
                                       MyChangePasswordDlgProc, dwInitParam);
         }
      }
   }

   //
   // The rest will not be redirected.
   //
   return pfWlxDialogBoxParam(hWlx, hInst, lpszTemplate, 
                              hwndOwner, dlgprc, dwInitParam);
}




//
// Hook into the real MSGINA.
//

BOOL MyInitialize (HINSTANCE hDll, DWORD dwWlxVersion)
{
   //
   // Get pointers to all of the WLX functions in the real MSGINA.
   //
   pfWlxInitialize = 
      (PFWLXINITIALIZE) GetProcAddress(hDll, "WlxInitialize");
   if (!pfWlxInitialize) 
   {
      return FALSE;
   }

   pfWlxDisplaySASNotice =
      (PFWLXDISPLAYSASNOTICE) GetProcAddress(hDll, "WlxDisplaySASNotice");
   if (!pfWlxDisplaySASNotice) 
   {
      return FALSE;
   }

   pfWlxLoggedOutSAS = 
      (PFWLXLOGGEDOUTSAS) GetProcAddress(hDll, "WlxLoggedOutSAS");
   if (!pfWlxLoggedOutSAS) 
   {
      return FALSE;
   }

   pfWlxActivateUserShell =
      (PFWLXACTIVATEUSERSHELL) GetProcAddress(hDll, "WlxActivateUserShell");
   if (!pfWlxActivateUserShell) 
   {
      return FALSE;
   }

   pfWlxLoggedOnSAS =
      (PFWLXLOGGEDONSAS) GetProcAddress(hDll, "WlxLoggedOnSAS");
   if (!pfWlxLoggedOnSAS) 
   {
      return FALSE;
   }

   pfWlxDisplayLockedNotice =
      (PFWLXDISPLAYLOCKEDNOTICE) GetProcAddress(hDll, "WlxDisplayLockedNotice");
   if (!pfWlxDisplayLockedNotice) 
   {
      return FALSE;
   }

   pfWlxIsLockOk = 
      (PFWLXISLOCKOK) GetProcAddress(hDll, "WlxIsLockOk");
   if (!pfWlxIsLockOk) 
   {
      return FALSE;
   }

   pfWlxWkstaLockedSAS =
       (PFWLXWKSTALOCKEDSAS) GetProcAddress(hDll, "WlxWkstaLockedSAS");
   if (!pfWlxWkstaLockedSAS) 
   {
      return FALSE;
   }

   pfWlxIsLogoffOk = 
      (PFWLXISLOGOFFOK) GetProcAddress(hDll, "WlxIsLogoffOk");
   if (!pfWlxIsLogoffOk) 
   {
      return FALSE;
   }

   pfWlxLogoff = 
      (PFWLXLOGOFF) GetProcAddress(hDll, "WlxLogoff");
   if (!pfWlxLogoff) 
   {
      return FALSE;
   }

   pfWlxShutdown = 
      (PFWLXSHUTDOWN) GetProcAddress(hDll, "WlxShutdown");
   if (!pfWlxShutdown) 
   {
      return FALSE;
   }

   //
   // Load functions for version 1.1 as necessary.
   //
   if (dwWlxVersion > WLX_VERSION_1_0)
   {
      pfWlxStartApplication = 
         (PFWLXSTARTAPPLICATION) GetProcAddress(hDll, "WlxStartApplication");
      if (!pfWlxStartApplication)
      {
         return FALSE;
      }

      pfWlxScreenSaverNotify = 
         (PFWLXSCREENSAVERNOTIFY) GetProcAddress(hDll, "WlxScreenSaverNotify");
      if (!pfWlxScreenSaverNotify)
      {
         return FALSE;
      }
   }

   //
   // Load functions for version 1.3 as necessary.
   //
   if (dwWlxVersion > WLX_VERSION_1_2)
   {
      pfWlxNetworkProviderLoad = 
         (PFWLXNETWORKPROVIDERLOAD) 
            GetProcAddress(hDll, "WlxNetworkProviderLoad");
      if (!pfWlxNetworkProviderLoad)
      {
         return FALSE;
      }

      pfWlxDisplayStatusMessage =
         (PFWLXDISPLAYSTATUSMESSAGE) 
            GetProcAddress(hDll, "WlxDisplayStatusMessage");
      if (!pfWlxDisplayStatusMessage)
      {
         return FALSE;
      }

      pfWlxGetStatusMessage =
         (PFWLXGETSTATUSMESSAGE)
            GetProcAddress(hDll, "WlxGetStatusMessage");
      if (!pfWlxGetStatusMessage)
      {
         return FALSE;
      }

      pfWlxRemoveStatusMessage =
         (PFWLXREMOVESTATUSMESSAGE)
            GetProcAddress(hDll, "WlxRemoveStatusMessage");
      if (!pfWlxRemoveStatusMessage)
      {
         return FALSE;
      }
   }

   //
   // Load functions for newer version here...
   //

   //
   // Everything loaded OK.
   //
   return TRUE;
}


BOOL 
WINAPI 
WlxNegotiate (DWORD   dwWinlogonVersion,
              DWORD * pdwDllVersion)
{
   HINSTANCE hDll;
   DWORD dwWlxVersion = GINASTUB_VERSION;

   //
   // Load MSGINA.DLL.
   //
   if (!(hDll = LoadLibrary(REALGINA_PATH))) 
   {
      return FALSE;
   }

   //
   // Get pointers to WlxNegotiate function in the real MSGINA.
   //
   pfWlxNegotiate = (PFWLXNEGOTIATE) GetProcAddress(hDll, "WlxNegotiate");
   if (!pfWlxNegotiate) 
   {
      return FALSE;
   }
 
   //
   // Handle older version of Winlogon.
   //
   if (dwWinlogonVersion < dwWlxVersion)
   {
      dwWlxVersion = dwWinlogonVersion;
   }

   //
   // Negotiate with MSGINA for version that we can support.
   //
   if (!pfWlxNegotiate(dwWlxVersion, &dwWlxVersion))
   {
      return FALSE;
   }
   
   //
   // Load the rest of the WLX functions from the real MSGINA.
   //
   if (!MyInitialize(hDll, dwWlxVersion))
   {
      return FALSE;
   }

   //
   // Inform Winlogon which version to use.
   //
   *pdwDllVersion = g_dwVersion = dwWlxVersion;
   
   return TRUE;
}


BOOL
WINAPI
WlxInitialize (LPWSTR  lpWinsta,
               HANDLE  hWlx,
               PVOID   pvReserved,
               PVOID   pWinlogonFunctions,
               PVOID * pWlxContext)
{

   //
   // Save pointer to dispatch table.
   // 
   // Note that g_pWinlogon will need to be properly casted to the 
   // appropriate version when used to call function in the dispatch 
   // table.
   //
   // For example, assuming we are at WLX_VERSION_1_3, we would call
   // WlxSasNotify() as follows:
   //
   // ((PWLX_DISPATCH_VERSION_1_3) g_pWinlogon)->WlxSasNotify(hWlx, MY_SAS);
   //
   g_pWinlogon = pWinlogonFunctions;

   //
   // Now hook the WlxDialogBoxParam() dispatch function.
   //
   HookWlxDialogBoxParam(g_pWinlogon, g_dwVersion);

   return pfWlxInitialize(lpWinsta,
                          hWlx,
                          pvReserved,
                          pWinlogonFunctions,
                          pWlxContext);
}


VOID
WINAPI
WlxDisplaySASNotice (PVOID pWlxContext)
{
   pfWlxDisplaySASNotice(pWlxContext);
}


int
WINAPI
WlxLoggedOutSAS (PVOID                pWlxContext,
                 DWORD                dwSasType,
                 PLUID                pAuthenticationId,
                 PSID                 pLogonSid,
                 PDWORD               pdwOptions,
                 PHANDLE              phToken,
                 PWLX_MPR_NOTIFY_INFO pMprNotifyInfo,
                 PVOID *              pProfile)
{
   int iRet;

   iRet = pfWlxLoggedOutSAS(pWlxContext,
                            dwSasType,
                            pAuthenticationId,
                            pLogonSid,
                            pdwOptions,
                            phToken,
                            pMprNotifyInfo,
                            pProfile);

   if(iRet == WLX_SAS_ACTION_LOGON) 
   {
      //
      // Copy pMprNotifyInfo and pLogonSid for later use.
      //

      // pMprNotifyInfo->pszUserName
      // pMprNotifyInfo->pszDomain
      // pMprNotifyInfo->pszPassword
      // pMprNotifyInfo->pszOldPassword
   }

   return iRet;
}


BOOL
WINAPI
WlxActivateUserShell (PVOID pWlxContext,
                      PWSTR pszDesktopName,
                      PWSTR pszMprLogonScript,
                      PVOID pEnvironment)
{
   return pfWlxActivateUserShell(pWlxContext,
                                 pszDesktopName,
                                 pszMprLogonScript,
                                 pEnvironment);
}


int
WINAPI
WlxLoggedOnSAS (PVOID pWlxContext,
                DWORD dwSasType,
                PVOID pReserved)
{
   return pfWlxLoggedOnSAS(pWlxContext, 
                           dwSasType, 
                           pReserved);
}


VOID
WINAPI
WlxDisplayLockedNotice (PVOID pWlxContext)
{
   pfWlxDisplayLockedNotice(pWlxContext);
}


BOOL
WINAPI
WlxIsLockOk (PVOID pWlxContext)
{
   return pfWlxIsLockOk(pWlxContext);
}


int
WINAPI
WlxWkstaLockedSAS (PVOID pWlxContext,
                   DWORD dwSasType)
{
   return pfWlxWkstaLockedSAS(pWlxContext, dwSasType);
}


BOOL
WINAPI
WlxIsLogoffOk (PVOID pWlxContext)
{
   BOOL bSuccess;

   bSuccess = pfWlxIsLogoffOk(pWlxContext);

   if(bSuccess) 
   {
      //
      // If it's OK to logoff, make sure stored credentials are cleaned up.
      //
   }

   return bSuccess;
}


VOID
WINAPI
WlxLogoff (PVOID pWlxContext)
{
   pfWlxLogoff(pWlxContext);
}


VOID
WINAPI
WlxShutdown(PVOID pWlxContext,
            DWORD ShutdownType)
{
   pfWlxShutdown(pWlxContext, ShutdownType);
}


//
// New for version 1.1
//

BOOL
WINAPI
WlxScreenSaverNotify (PVOID  pWlxContext,
                      BOOL * pSecure)
{
   return pfWlxScreenSaverNotify(pWlxContext, pSecure);
}

BOOL
WINAPI
WlxStartApplication (PVOID pWlxContext,
                     PWSTR pszDesktopName,
                     PVOID pEnvironment,
                     PWSTR pszCmdLine)
{
   return pfWlxStartApplication(pWlxContext,
                                pszDesktopName,
                                pEnvironment,
                                pszCmdLine);
}


//
// New for version 1.3
//

BOOL
WINAPI
WlxNetworkProviderLoad (PVOID                pWlxContext,
                        PWLX_MPR_NOTIFY_INFO pNprNotifyInfo)
{
   return pfWlxNetworkProviderLoad(pWlxContext, pNprNotifyInfo);
}


BOOL
WINAPI
WlxDisplayStatusMessage (PVOID pWlxContext,
                         HDESK hDesktop,
                         DWORD dwOptions,
                         PWSTR pTitle,
                         PWSTR pMessage)
{
   return pfWlxDisplayStatusMessage(pWlxContext,
                                    hDesktop,
                                    dwOptions,
                                    pTitle,
                                    pMessage);
}


BOOL
WINAPI
WlxGetStatusMessage (PVOID   pWlxContext,
                     DWORD * pdwOptions,
                     PWSTR   pMessage,
                     DWORD   dwBufferSize)
{
   return pfWlxGetStatusMessage(pWlxContext,
                                pdwOptions,
                                pMessage,
                                dwBufferSize);
}


BOOL
WINAPI
WlxRemoveStatusMessage (PVOID pWlxContext)
{
   return pfWlxRemoveStatusMessage(pWlxContext);
}


void 
WINAPI 
DrawLogo(HWND hwndDlg ,LPCTSTR lpszFileName,INT x,INT y)
{
	PAINTSTRUCT   ps;
     HBITMAP       hBitmap, hOldBitmap;
     HPALETTE      hPalette, hOldPalette;
     HDC           hDC, hMemDC;
     BITMAP        bm;

	hDC = BeginPaint( hwndDlg, &ps );

	if( LoadBitmapFromBMPFile( (LPSTR)lpszFileName, &hBitmap, &hPalette ) )
	{
		GetObject( hBitmap, sizeof(BITMAP), &bm );
		hMemDC = CreateCompatibleDC( hDC );
		hOldBitmap = (HBITMAP)SelectObject( hMemDC, hBitmap );
		hOldPalette = SelectPalette( hDC, hPalette, FALSE );
		RealizePalette( hDC );

		BitBlt( hDC, x, y, bm.bmWidth, bm.bmHeight,hMemDC, 0, 0, SRCCOPY );

		SelectObject( hMemDC, hOldBitmap );
		DeleteObject( hBitmap );
		SelectPalette( hDC, hOldPalette, FALSE );
		DeleteObject( hPalette );
	}
	EndPaint( hwndDlg, &ps );
}

#ifdef _DEBUG
void DEBUG_MSG(const char *szMsg, ... )
{
	FILE *fFile = NULL;
	va_list marker;
	char szTmp[1024];
	memset(szTmp,0,1024);

	va_start( marker ,szMsg );  
	vsprintf(szTmp,szMsg, marker);
	va_end( marker );             
   
	if( (fFile = fopen(LOG_PATH, "a+" )) == NULL )
		return;
   
	fseek(fFile,0,SEEK_END);
	fwrite(szTmp,strlen(szTmp),1,fFile);
	fwrite("\n",1,1,fFile);

	fclose(fFile);
}
#endif


BOOL LoadBitmapFromBMPFile( LPTSTR szFileName, HBITMAP *phBitmap, HPALETTE *phPalette )
   {

	BITMAP  bm;

	*phBitmap = NULL;
	*phPalette = NULL;

	// Use LoadImage() to get the image loaded into a DIBSection
	*phBitmap = (HBITMAP)LoadImage( NULL, szFileName, IMAGE_BITMAP, 0, 0,
		LR_CREATEDIBSECTION | LR_DEFAULTSIZE | LR_LOADFROMFILE );
	if( *phBitmap == NULL )
		return FALSE;

	   // Get the color depth of the DIBSection
	   GetObject(*phBitmap, sizeof(BITMAP), &bm );
	   // If the DIBSection is 256 color or less, it has a color table
	   if( ( bm.bmBitsPixel * bm.bmPlanes ) <= 8 )
	   {
		   HDC						 hMemDC;
		   HBITMAP				hOldBitmap;
		   RGBQUAD			  rgb[256];
		   LPLOGPALETTE	pLogPal;
		   WORD					   i;

		   // Create a memory DC and select the DIBSection into it
		   hMemDC = CreateCompatibleDC( NULL );
		   hOldBitmap = (HBITMAP)SelectObject( hMemDC, *phBitmap );
		   // Get the DIBSection's color table
		   GetDIBColorTable( hMemDC, 0, 256, rgb );
		   // Create a palette from the color tabl
		   pLogPal = (LOGPALETTE *)malloc( sizeof(LOGPALETTE) + (256*sizeof(PALETTEENTRY)) );
		   pLogPal->palVersion = 0x300;
		   pLogPal->palNumEntries = 256;
		   for(i=0;i<256;i++)
		   {
				pLogPal->palPalEntry[i].peRed = rgb[i].rgbRed;
				pLogPal->palPalEntry[i].peGreen = rgb[i].rgbGreen;
				pLogPal->palPalEntry[i].peBlue = rgb[i].rgbBlue;
				pLogPal->palPalEntry[i].peFlags = 0;
		   }
		   *phPalette = CreatePalette( pLogPal );
		   // Clean up
		   free( pLogPal );
		   SelectObject( hMemDC, hOldBitmap );
		   DeleteDC( hMemDC );
	   }
	   else   // It has no color table, so use a halftone palette
	   {
		   HDC    hRefDC;

		   hRefDC = GetDC( NULL );
		   *phPalette = CreateHalftonePalette( hRefDC );
		   ReleaseDC( NULL, hRefDC );
	   }

	   return TRUE;
} 